/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package glassfisherrorclient;

import java.util.ArrayList;
import java.util.Collection;
import javax.swing.SwingWorker;

/**
 *
 * @author gjd37
 */
public class Main {

    public static void main(String[] args) {
        // TODO code application logic here
        final int[] finished = {0};
        final int[] failed = {0};

        try { // Call Web Service Operation

            final test.TestConcurrentBeanService service = new test.TestConcurrentBeanService();
            final test.TestConcurrentBean port = service.getTestConcurrentBeanPort();
            
            Collection<SwingWorker> sws = new ArrayList<SwingWorker>();

            for (int i = 0; i < 100; i++) {

                SwingWorker sw = new SwingWorker<String, String>() {

                    @Override
                    public String doInBackground() {

                        try {
                            java.lang.String result = port.testMethod();
                            System.out.println("Result "+result);
                        } catch (Exception ex) {
                            System.out.println("Error with: " + ex);                           
                            failed[0]++;
                        }
                        return "finished";
                    }

                    @Override
                    public void done() {
                        try {
                            get();
                            System.out.println("finished ok " + finished[0]++ + ", failed " + failed[0]);
                        } catch (Exception ex) {
                            finished[0]++;
                            System.out.println(ex.getMessage());
                        }
                    }
                };

                sws.add(sw);
            }

            //now execute them
            int i = 0;
            Thread.sleep(2000);
            for (SwingWorker swingWorker : sws) {
                //Thread.sleep(50);
                System.out.println("Starting" + i++);
                swingWorker.execute();
            }

        } catch (Exception ex) {
            System.out.println(ex);
        // TODO handle custom exceptions here
        }
    }
}
